.module Program
; ---------------------------------------------------------
; Main -> Program entry point.
; ---------------------------------------------------------
Main

	call GUI.Reset

-	call VMusic2.TiLP.ReadByteFast
	jr z,{-}
	call GUI.RefreshFileList

GuiLoop
	call VMusic2.TiLP.ReadByteFast
	jr z,GuiLoop
	
	call GUI.Draw
	call ionFastCopy
	bcall(_GetCSC)
	cp skClear
	ret z
	
	push af
	ld hl,GUI.DirOffset
	ld a,(GUI.SelectedCol)
	or a
	jr z,{+}
	ld hl,GUI.FileOffset
+
	pop af
	
	cp skUp
	jr nz,{+}
	dec (hl)
+	cp skDown
	jr nz,{+}
	inc (hl)
+
	
	cp skLeft
	jr nz,{+}
	push af
	xor a
	ld (GUI.SelectedCol),a
	pop af
+	cp skRight
	jr nz,{+}
	push af
	ld a,1
	ld (GUI.SelectedCol),a
	pop af
+
	
	cp skGraph
	jr nz,{+}
	call GUI.RefreshFileList
+

	cp sk2nd
	jr nz,{+}
	call GUI.GetSelectedName
	
	ld a,(GUI.SelectedCol)
	or a
	jr nz,PlayMusic	
	call VMusic2.Directory.Change
	call GUI.RefreshFileList
	jr GuiLoop
PlayMusic
	call VMusic2.Music.Play
	jr GuiLoop
+

	cp skYEqu
	jr nz,{+}
	call VMusic2.Music.PlayAll
	jr GuiLoop
+
	cp skWindow
	jr nz,{+}
	call VMusic2.Music.Stop
	jr GuiLoop
+
	
	jr GuiLoop


AppLoop
	bcall(_GetCSC)
	cp skClear
	ret z
	jr AppLoop
	
	cp skAlpha
	jr nz,{+}
	ld a,(TextInput.EditMode)
	inc a
	and $E3
	ld (TextInput.EditMode),a
	jr AppLoop
+

	cp sk2nd
	jr nz,{+}
	
	call VMusic2.Music.PlayAll
	jr AppLoop
+
	
	call TextInput.SafeScancodeToChar
	jr nz,{+}
	push af
	call VMusic2.TiLP.WriteByte
	pop af
	jr PutChar
+	
	
-	call VMusic2.TiLP.ReadByteFast
	jr nz,AppLoop
PutChar
	call FixedWidth.PutC
	call ionFastCopy
	jr {-}
	ret



.include "VMusic2/VMusic2.asm"
.include "GUI.asm"
.include "TextInput.asm"
.include "FixedWidth.asm"
.include "Resources/Resources.inc"
.include "Dialogs.asm"
.endmodule